require 'jwt_manager'
require 'token_storage'

class TokenDecoder
  attr_reader :token

  def initialize(token)
    @token = token
  end

  def decode
    jwt = load_jwt_from_link
    decrypted_jwt(jwt)
  end

  private

  def load_jwt_from_link
    TokenStorage.new.load(token)
  end

  def decrypted_jwt(jwt)
    JWTManager.decode(jwt)
  end
end
